#ifndef CSR_GRAPH_HPP
#define CSR_GRAPH_HPP

#include <utils/Array.hpp>

class CSRGraph
{
 private:
  Array<int> m_entries;
  Array<int> m_neighbors;

 public:
  size_t
  numberOfNodes() const
  {
    Assert(m_entries.size() > 0);
    return m_entries.size() - 1;
  }

  const Array<int>&
  entries() const
  {
    return m_entries;
  }

  const Array<int>&
  neighbors() const
  {
    return m_neighbors;
  }

  CSRGraph& operator=(CSRGraph&&) = default;
  CSRGraph& operator=(const CSRGraph&) = default;

  CSRGraph(const Array<int>& entries, const Array<int>& neighbors) : m_entries(entries), m_neighbors(neighbors)
  {
    Assert(m_entries.size() > 0);
  }

  CSRGraph()                = default;
  CSRGraph(CSRGraph&&)      = default;
  CSRGraph(const CSRGraph&) = default;
  ~CSRGraph()               = default;
};

#endif   // CSR_GRAPH_HPP
